	   SUBROUTINE UMAT(STRESS,STATEV,DDSDDE,SSE,SPD,SCD,
     1 RPL,DDSDDT,DRPLDE,DRPLDT,
     2 STRAN,DSTRAN,TIME,DTIME,TEMP,DTEMP,PREDEF,DPRED,CMNAME,
     3 NDI,NSHR,NTENS,NSTATV,PROPS,NPROPS,COORDS,DROT,PNEWDT,
     4 CELENT,DFGRD0,DFGRD1,NOEL,NPT,LAYER,KSPT,JSTEP,KINC)
C
      INCLUDE 'ABA_PARAM.INC'
C
      CHARACTER*80 CMNAME
      DIMENSION STRESS(NTENS),STATEV(NSTATV),
     1 DDSDDE(NTENS,NTENS),DDSDDT(NTENS),DRPLDE(NTENS),
     2 STRAN(NTENS),DSTRAN(NTENS),TIME(2),PREDEF(1),DPRED(1),
     3 PROPS(NPROPS),COORDS(3),DROT(3,3),DFGRD0(3,3),DFGRD1(3,3),
     4 JSTEP(4),ALPHA(NTENS),FLOW(NTENS)

		PARAMETER( ZERO = 0. , ONE = 1. , TWO = 2. , THREE = 3., SIX= 6.)

		EMOD= PROPS(1)
		ENU=PROPS(2)
		EBULK = EMOD/(ONE- TWO*ENU)/THREE
		EBULK3 = EMOD/(ONE- TWO*ENU)
		EG2=EMOD/(ONE+ENU)
		EG=EG2/TWO
		EG3=THREE*EG
		ELAM=(EBULK3-EG2)/THREE
		
		!ELASTIC
		DDSDDE=0.0
		
		DO K1=1,NDI
			DO K2=1,NDI
				DDSDDE(K2,K1)=ELAM
			END DO
			DDSDDE(K1,K1)=ELAM + EG2
		END DO
		
		DO K1=NDI+1,NTENS
			DDSDDE(K1,K1)=EG
		END DO
		
		
		DO K1=1,NTENS
			DO K2=1,NTENS
				STRESS(K1)=STRESS(K1)+DDSDDE(K1,K2)*DSTRAN(K2)
				
			END DO	
		END DO
		
		!PLASTIC
		
		CALL ROTSIG(STATEV,DROT,ALPHA,1,NDI,NSHR)
		
		SMISES = (STRESS(1)-ALPHA(1)-STRESS(2)+ALPHA(2))**2
		SMISES = SMISES+(STRESS(1)-ALPHA(1)-STRESS(3)+ALPHA(3))**2
		SMISES = SMISES+(STRESS(2)-ALPHA(2)-STRESS(3)+ALPHA(3))**2
		
		DO K1=NDI+1,NTENS
			SMISES = SMISES+SIX*(STRESS(K1)-ALPHA(K1))**2
		END DO
		
		SMISES = SQRT(SMISES/TWO)
		
		SYIELD = PROPS(3)
		HARD = PROPS(4)
		
		IF (SMISES .GT. (ONE+ 0.00001)*SYIELD ) THEN
		
		DEQPL = (SMISES-SYIELD) / (EG3+HARD)
		
		SHYDRO = (STRESS(1) + STRESS(2) + STRESS(3))/THREE
		
		DO K1=1,NDI
			FLOW(K1) = (STRESS(K1) - ALPHA(K1)-SHYDRO)/SMISES
		END DO
		
		DO K1=NDI+1,NTENS
			FLOW(K1) = (STRESS(K1) - ALPHA(K1))/SMISES
		END DO
		
		
		!ALPHA
		
		DO K1=1,NDI
			ALPHA(K1) = ALPHA(K1) + HARD * FLOW(K1)*DEQPL
			
			STRESS(K1) = ALPHA(K1) + FLOW(K1) * SYIELD + SHYDRO
			
		END DO
		
		DO K1=NDI+1,NTENS
			ALPHA(K1) = ALPHA(K1) + HARD * FLOW(K1)*DEQPL
			
			STRESS(K1) = ALPHA(K1) + FLOW(K1) * SYIELD
			
		   
		END DO
		
		
		!STORING THE ALPHAS
		DO K1=1,NTENS
			STATEV(K1) = ALPHA(K1)		
		END DO
		
		EFFG = EG*(SYIELD+HARD*DEQPL)/SMISES
		EFFG2 = TWO*EFFG
		EFFG3 = THREE*EFFG
		EFFLAM = (EBULK3-EFFG2)/THREE
		EFFHARD = EG3*HARD/(EG3+HARD)-EFFG3
		
		DO K1=1,NDI
			DO K2=1,NDI
			DDSDDE(K2,K1) = EFFLAM
			END DO
			DDSDDE(K1,K1) = EFFG2 + EFFLAM
			
		END DO
		
		DO K1=NDI+1,NTENS
			DDSDDE(K1,K1) = EFFG
		END DO
		
		
		DO K1=1,NTENS
			DO K2=1,NTENS
			DDSDDE(K2,K1) = DDSDDE(K2,K1) + EFFHARD*FLOW(K2)*FLOW(K1)
			PRINT*,"DDSDDE(",1,",",1,")=",DDSDDE(1,1)
	
		
			END DO
		END DO
		
		
		
		END IF
		
        

      RETURN
      END